/* $Id: merge.c,v 1.2 2008/02/22 17:53:50 dw Exp $ */
/* Author Damian Weber, www-crypto.htw-saarland.de, License: BSD */


#include <stdlib.h>

/* merge the two sorted subsequences
 * a[l...k] and a[k+1...r] into one sorted sequence
 * a[l...r]
 */

void merge(int l, int k, int r, int *a)
{
	int i,j,m;
	int *z;

	z=(int *) malloc((r-l+1)*sizeof(int));


	m=0; /* to fill z[] */
	i=l; /* to walk through the left sequence */
	j=k+1; /* to walk through the right sequence */

	while (i<=k && j<=r)
	{
		if (a[i]<a[j]) 
		{
			z[m]=a[i]; i++; m++;
		}
		else
		{
			z[m]=a[j]; j++; m++;
		}
	}

	while (j<=r)
	{
		z[m]=a[j]; j++; m++;
	}

	while (i<=k)
	{
		z[m]=a[i]; i++; m++;
	}

	for (i=l;i<=r;i++)
		a[i]=z[i-l];

	free(z);
}
/* if l+1=r, the sorted sequence is obtained by a single swap
 * if l+1<r, split the sequence into a[l...k] and  a[k+1...r]
 * call mergesort(l,k) and mergesort(k+1,r)
 * and merge the two sequences together
 */

void merge_sort_r(int l, int r, int *a) 
{
	int t;
	int k;

	if (l>=r) return; /* nothing to do */

	if (l+1==r)
	{
		if (a[l]<a[r]) return;
		t=a[l]; a[l]=a[r]; a[r]=t;
		return;
	}

	k=(l+r)/2;

	merge_sort_r(l,k,a);
	merge_sort_r(k+1,r,a);

	merge(l,k,r,a);
}

/* merge sort for the a[0...n-1] */

void merge_sort(int n, int *a) 
{
	merge_sort_r(0,n-1,a);
}
