/* $Id: shell.c,v 1.1 2001/07/24 17:10:50 dw Exp $ */
/* Author Damian Weber, www-crypto.htw-saarland.de, License: BSD */


/* shell sort for the a[0...n-1] */


void insertion_sort_h(int n,int *a, int h)
{
	int i,j;
	int u;
	int h0;

	for (h0=h;h0<2*h;h0++)
		for (i=h0;i<n;i+=h)
		{
			u=a[i];
			j=i-h;
			while (j>=0 && a[j]>u)
			{
				a[j+h]=a[j];
				j-=h;
			}
			a[j+h]=u;
		}
}

void shell_sort(int n,int *a)
{
	insertion_sort_h(n,a,3);
	insertion_sort_h(n,a,1);
}

#ifdef USE_KAISERS_SHELL_SORT
void insertion_sort_h(int n,int *a, int h)
{
	int i,j;
	int u;

	for (i=h;i<n;i+=h)
	{
		u=a[i];
		j=i-h;
		while (j>=0 && a[j]>u)
		{
			a[j+h]=a[j];
			j-=h;
		}
		a[j+h]=u;
	}
}

void shell_sort(int n,int *a)
{
	int h;

	h=1;

	while (h<=n/16) h=4*h+1;

	while (h>0)
	{
		insertion_sort_h(n,a,h);
		h/=4;
	}
}

#endif

